//**************************************************************\\
//*          Huuto.net API esimerkki / Osastojen haku          *\\
//*                                                            *\\
//*     Huudon osastorakenteen hakeminen JSON apin kautta      *\\
//*                                                            *\\
//*              Lazarus 1.6.2 (vain Windows)                  *\\
//*                                                            *\\
//*                      09.01-2017                            *\\
//*                                                            *\\
//*                  Email: info@pilvet.fi                     *\\
//*                  Web: http://pilvet.fi                     *\\
//**************************************************************\\

unit Unit1;

{$MODE Delphi}

interface

uses
  Windows, SysUtils, Variants, Classes, Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, Comobj, LazUTF8;

type

  { TForm1 }

  TForm1 = class(TForm)
    Memo1: TMemo;
    Panel1: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    SaveDialog1: TSaveDialog;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    function kopioi_alkaen(source: string; alkaen: integer): string;
  private
    { Private declarations }
  public
    { Public declarations }
  end;

const virhe = 'Hakua ei voitu suorittaa!';
var
  Form1: TForm1;
  httpreq: variant;
  pysayta: boolean;
  osastot: string;

implementation

{$R *.lfm}

function JsonUnescape(const s: ansiString): string;
var i, j, c: Integer;
begin
 SetLength(Result, Length(s));
 i:=1;
 j:=1;
 while i<=Length(s) do
 begin
  if (s[i]='\') and (i<Length(s)) then
  begin
   if (s[i+1]='\') or (s[i+1]='/') or (s[i+1]='"') then
   begin
    Result[j]:=Char(s[i+1]);
    inc(i, 2);
   end
   else if (s[i+1]='r') then
   begin
    Result[j]:=Char(#13);
    inc(i, 2);
   end
   else if (s[i+1]='n') then
   begin
    Result[j]:=Char(#10);
    inc(i, 2);
   end
   else if (s[i+1]='u') and (i+5<=Length(s)) and TryStrToInt('$'+string(Copy(s, i+2, 4)), c) then
   begin
    inc(i, 6);
    Result[j]:=Char(c);
   end
   else
   begin
    Result[j]:=Char(s[i]);
    inc(i);
   end;
  end
  else
  begin
   Result[j]:=Char(s[i]);
   inc(i);
  end;
  inc(j);
 end;
 SetLength(Result, j-1);
end;

function TForm1.kopioi_alkaen(source: string; alkaen: integer): string;
begin
 result:=copy(source, alkaen, length(source)-alkaen+1);
end;

function xmlhttpget(fileURL: string): string;
var StartedTime, aika: DWord;
    URL: Olevariant;
    ar: array of byte;
    body: widestring;
begin
 result:='';
 aika:=20000;
 URL:=fileURL;
 StartedTime:=GetTickCount;
 try
  httpreq.open('GET', URL, true);
  httpreq.setRequestHeader('Content-Type', 'text/xml');
  httpreq.send();
  while (httpreq.readystate<>4) and (GetTickCount<startedtime+aika) and (pysayta=false) do
   begin application.processmessages; sleep(10); end;
  if (GetTickCount>=startedtime+aika) or (pysayta=true) then
  begin
   httpreq.abort;
   exit;
  end;
  if ((httpreq.status=200) or (httpreq.status=0)) and (httpreq.responsetext<>'') then
  begin
   ar:=httpreq.responsebody;
   if length(ar)>0 then
   begin
    SetString(body, PansiChar(@ar[0]), length(ar));
    result:=JsonUnescape(body);
   end;
  end;
 except; httpreq.abort; end;
end;

function nocache: string;
begin
 result:=inttostr(random(100000));
end;

procedure TForm1.Button1Click(Sender: TObject);
var s, title, id: string;
    i, j, k, laskuri: integer;
    itemit, itemit2, itemit3: array of array[1..2] of string;
begin
 memo1.text:='';
 osastot:='';
 pysayta:=false;
 button2.enabled:=false;
 setlength(itemit,0);
 s:=xmlhttpget('http://api.huuto.net/1.1/categories?nocache='+nocache);
 if s='' then
 begin
  showmessage(virhe);
  exit;
 end;
 laskuri:=0;
 i:=ansipos('"id":', ansilowercase(s));
 while i>0 do
 begin
  s:=kopioi_alkaen(s, i+5);
  i:=ansipos(',"', s);
  id:=copy(s, 1, i-1);
  i:=ansipos('"title":', ansilowercase(s));
  s:=kopioi_alkaen(s, i+8);
  i:=ansipos(',"', s);
  title:=copy(s, 1, i-1);
  title:=stringreplace(title, '"', '', [rfreplaceall]);
  i:=ansipos('"id":', ansilowercase(s));
  setlength(itemit, length(itemit)+1);
  itemit[laskuri,1]:=id;
  itemit[laskuri,2]:=title;
  laskuri:=laskuri+1;
 end;
 for j:=1 to length(itemit)-1 do
 begin
  if pysayta=true then exit;
  osastot:=osastot+'m'+itemit[j,1]+'='+itemit[j,2]+#13#10;
  setlength(itemit2,0);
  s:=xmlhttpget('http://api.huuto.net/1.1/categories/'+itemit[j,1]+'/subcategories?nocache='+nocache);
  if s='' then
  begin
   showmessage(virhe);
   exit;
  end;
  laskuri:=0;
  i:=ansipos('"id":', ansilowercase(s));
  while i>0 do
  begin
   s:=kopioi_alkaen(s, i+5);
   i:=ansipos(',"', s);
   id:=copy(s, 1, i-1);
   i:=ansipos('"title":', ansilowercase(s));
   s:=kopioi_alkaen(s, i+8);
   i:=ansipos(',"', s);
   title:=copy(s, 1, i-1);
   title:=stringreplace(title, '"', '', [rfreplaceall]);
   i:=ansipos('"id":', ansilowercase(s));
   setlength(itemit2, length(itemit2)+1);
   itemit2[laskuri,1]:=id;
   itemit2[laskuri,2]:=title;
   laskuri:=laskuri+1;
  end;
  for k:=1 to length(itemit2)-1 do
  begin
   if pysayta=true then exit;
   osastot:=osastot+'s'+itemit2[k,1]+'='+itemit2[k,2]+#13#10;
   setlength(itemit3,0);
   s:=xmlhttpget('http://api.huuto.net/1.1/categories/'+itemit2[k,1]+'/subcategories?nocache='+nocache);
   if s='' then
   begin
    showmessage(virhe);
    exit;
   end;
   laskuri:=0;
   i:=ansipos('"id":', ansilowercase(s));
   while i>0 do
   begin
    s:=kopioi_alkaen(s, i+5);
    i:=ansipos(',"', s);
    id:=copy(s, 1, i-1);
    i:=ansipos('"title":', ansilowercase(s));
    s:=kopioi_alkaen(s, i+8);
    i:=ansipos(',"', s);
    title:=copy(s, 1, i-1);
    title:=stringreplace(title, '"', '', [rfreplaceall]);
    i:=ansipos('"id":', ansilowercase(s));
    setlength(itemit3, length(itemit3)+1);
    itemit3[laskuri,1]:=id;
    itemit3[laskuri,2]:=title;
    if laskuri>0 then osastot:=osastot+'c'+id+'='+title+#13#10;
    laskuri:=laskuri+1;
   end;
  end;
  memo1.text:=WinCPToUTF8(osastot);
 end;
 showmessage('Ok');
 button2.enabled:=true;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 if savedialog1.execute then memo1.Lines.SaveToFile(savedialog1.filename);
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
 pysayta:=true;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 httpreq:=CreateOleObject('MSXML2.XMLHTTP.6.0');
 randomize;
end;

end.
